package com.gyee.frame.netty.websocket;

import java.io.IOException;
import java.net.BindException;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CopyOnWriteArraySet;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;

import com.gyee.frame.common.quartz.SocketTaskUtil;
import org.springframework.stereotype.Component;
import cn.hutool.log.Log;
import cn.hutool.log.LogFactory;

/**
 *@author:Wang Jiawen
 *
 *@description: socketserver 封装类
 *
 *@createTime:2019/12/31
 *
 */

@ServerEndpoint(value = "/websocket/{pageNumber}/{functionNumber}",encoders = { ServerEncoder.class })
@Component
public class WebSocketServer extends SocketTaskUtil {

	static Log log=LogFactory.get(WebSocketServer.class);
    //静态变量，用来记录当前在线连接数。应该把它设计成线程安全的。
    private static int onlineCount = 0;
    //concurrent包的线程安全Set，用来存放每个客户端对应的MyWebSocket对象,准备弃用
    private static CopyOnWriteArraySet<WebSocketServer> webSocketSet = new CopyOnWriteArraySet<WebSocketServer>();
    //功能名称与页面名称为key 举例 页面名称_功能名称
    private static Map<String,WebSocketServer> webSocketMap = new HashMap();

    //与某个客户端的连接会话，需要通过它来给客户端发送数据
    private Session session;

    //接收sid
    private String sid="";
    //接收pageNumber
    private String pageNumber="";
    //接收functionNumber
    private String functionNumber="";
    /**
     * 连接建立成功调用的方法*/
    @OnOpen
    public void onOpen(Session session,@PathParam("pageNumber") String pageNumber,@PathParam("functionNumber") String functionNumber) {
        this.session = session;
        webSocketMap.put((pageNumber+"_"+functionNumber),this);
        webSocketSet.add(this);     //加入set中
        addOnlineCount();           //在线数加1
        log.info("有新窗口开始监听:页面编码:"+pageNumber+",功能编码:"+functionNumber+",当前在线人数为" + getOnlineCount());
        //目标连接成功后注入基本信息
        this.sid=sid;
        this.pageNumber=pageNumber; //页面编码
        this.functionNumber=functionNumber;//功能编码
        log.info("连接成功");
        if(getOnlineCount()>=1){
            this.restartJob((pageNumber+"_"+functionNumber));//重启任务
        }
    }

    /**
     * 连接关闭调用的方法
     */
    @OnClose
    public void onClose() {
        webSocketMap.remove(this.pageNumber+"_"+this.functionNumber);
        webSocketSet.remove(this);  //从set中删除
        subOnlineCount();           //在线数减1
        log.info("有一连接关闭！当前在线人数为" + getOnlineCount());
        if(getOnlineCount()==0){
            this.deleteJob((pageNumber+"_"+functionNumber));//关闭任务
        }
    }

    /**
     * 收到客户端消息后调用的方法
     *
     * @param message 客户端发送过来的消息*/
    @OnMessage
    public void onMessage(String message, Session session) {
    	log.info("收到来自窗口:"+pageNumber+",功能编码:"+functionNumber+"的信息:"+message);
        //群发消息
        for (WebSocketServer item : webSocketSet) {
            try {
                item.sendMessage(message);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

	/**
	 * 
	 * @param session
	 * @param error
	 */
    @OnError
    public void onError(Session session, Throwable error) {
        log.error("发生错误");
        error.printStackTrace();
    }
	/**
	 * 实现服务器主动推送
	 */
    public void sendMessage(String message) throws IOException {
        this.session.getBasicRemote().sendText(message);
    }
    /**
     *@author:Wang Jiawen
     *
     *@description:直接发送object类型消息，实现服务器主动推送，新增传输object类型消息
     *
     *@param:[message] object
     *
     *@return:void
     *
     *@createTime:2020/1/9
     *
     */
    public void sendMessage(Object message) throws IOException, EncodeException {
        this.session.getBasicRemote().sendObject(message);
    }

    /**
     * 群发自定义消息
     * */
    public static void sendInfo(Object message,@PathParam("pageNumber") String pageNumber,@PathParam("functionNumber") String functionNumber) throws IOException, EncodeException {
    	log.info("推送消息到窗口:"+pageNumber+",功能编码:"+functionNumber+"的信息:"+message);
        WebSocketServer item = webSocketMap.get(pageNumber + "_" + functionNumber);

        //这里可以设定只推送给这个sid的，为null则全部推送
        if(functionNumber==null||pageNumber==null) {
            throw new BindException("请核对编码信息(包括页面编码以及功能编码非空)");
        }else if(item.pageNumber.equals(pageNumber)&&item.functionNumber.equals(functionNumber)){
            item.sendMessage(message);
        }
        //利用set容器循环的方式暂时被关闭,原因节约资源
/*        for (WebSocketServer item : webSocketSet) {
            try {
            	//这里可以设定只推送给这个sid的，为null则全部推送
            	if(functionNumber==null||pageNumber==null) {
                    throw new BindException("请核对编码信息");
            	}else if(item.pageNumber.equals(pageNumber)&&item.functionNumber.equals(functionNumber)){
            		item.sendMessage(message);
            	}
            } catch (IOException e) {
                e.printStackTrace();
                continue;
            }
        }*/
    }
    public void sendObject(Object message,@PathParam("pageNumber") String pageNumber,@PathParam("functionNumber") String functionNumber) throws IOException, EncodeException {
        log.info("推送消息到窗口:"+pageNumber+",功能编码:"+functionNumber+"的信息:"+message);
        WebSocketServer item = webSocketMap.get(pageNumber + "_" + functionNumber);

        //这里可以设定只推送给这个sid的，为null则全部推送
        if(functionNumber==null||pageNumber==null) {
            throw new BindException("请核对编码信息(包括页面编码以及功能编码非空)");
        }else if(item.pageNumber.equals(pageNumber)&&item.functionNumber.equals(functionNumber)){
            item.sendMessage(message);
        }
        //利用set容器循环的方式暂时被关闭,原因节约资源
/*        for (WebSocketServer item : webSocketSet) {
            try {
            	//这里可以设定只推送给这个sid的，为null则全部推送
            	if(functionNumber==null||pageNumber==null) {
                    throw new BindException("请核对编码信息");
            	}else if(item.pageNumber.equals(pageNumber)&&item.functionNumber.equals(functionNumber)){
            		item.sendMessage(message);
            	}
            } catch (IOException e) {
                e.printStackTrace();
                continue;
            }
        }*/
    }

    public static synchronized int getOnlineCount() {
        return onlineCount;
    }

    public static synchronized void addOnlineCount() {
        WebSocketServer.onlineCount++;
    }

    public static synchronized void subOnlineCount() {
        WebSocketServer.onlineCount--;
    }
}

